#ifndef D88_H_INCLUDED
#define D88_H_INCLUDED

#include <limits.h>

#include "pc6001v.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cD88 {
private:
	// D88 ¤
	typedef struct{
		BYTE c;				// ID  C (No ̤ξ=ȥåNo)
		BYTE h;				// ID  H (إåɥ쥹 ̤ξ=0)
		BYTE r;				// ID  R (ȥåΥNo)
		BYTE n;				// ID  N ( 0:256 1:256 2:512 3:1024)
		WORD sec_nr;		// Υȥå¸ߤ륻ο
		BYTE density;		// Ͽ̩     0x00:̩   0x40:ñ̩
		BYTE deleted;		// DELETED MARK 0x00:Ρޥ 0x10:DELETED
		BYTE status;		// ơ
		BYTE reserve[5];	// ꥶ
		WORD size;			// ΥΥǡ
		DWORD data;			// ǡؤΥեå
		WORD offset;		// ɹǡΥƬΥեå
	} D88SECTOR;
	
	// D88 ¤
	typedef struct{
		BYTE name[17];		// ǥ̾(ASCII + '\0')
		BYTE reserve[9];	// ꥶ
		BYTE protect;		// 饤ȥץƥ  0x00:ʤ 0x10:
		BYTE type;			// ǥμ    0x00:2D   0x10:2DD  0x20:2HD
		DWORD size;			// ǥΥ(إå+ȥå)
		DWORD table[164];	// ȥåΥեåȥơ֥(Track 0-163)
		D88SECTOR secinfo;	// 
		FILE *fp;			// FILE ݥ
	} D88INFO;
	
	D88INFO d88;				// D88 
	char FileName[PATH_MAX];	// ե̾Хåե
	
	BOOL Protected;				// ץƥȥ
	
	void ReadHeader88();		// D88 إåɹ
	void ReadSector88();		// D88 ɹ
	
public:
	cD88();						// 󥹥ȥ饯
	~cD88();					// ǥȥ饯
	
	BOOL Init( char * );		// 
	
	BYTE Getc88();				// 1byte ɹ
	BOOL Putc88( BYTE );		// 1byte 
	BOOL Seek88( int, int );	// 
	DWORD GetCHRN();			// ߤCHRN
	
	char *GetFileName();		// ե̾
	char *GetDiskImgName();		// DISK᡼̾
	BOOL IsProtect();			// ץƥȥּ
};

#endif	// D88_H_INCLUDED
