#ifndef KEYBOARD_H_INCLUDED
#define KEYBOARD_H_INCLUDED

#include "pc6001v.h"
#include "ini.h"
#include "joystick.h"
#include "keydef.h"

#include "p6device.h"


// ޥȥꥯ
#define	NOM			(16)

// ܡɥ󥸥
#define	KI_KANA		(1)
#define	KI_KKANA	(2)
#define	KI_CAPS		(4)


// P6Υޥȥꥯޥå
typedef struct {
	BYTE Keys[8][8];	// ޥȥꥯޥå
} P6MxMap;


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class KEY6 : public P6DEVENT, public cJoy, public IDoko {
protected:
	PCKEYsym VKTable[SDLK_LAST];	// SDL  -> ۥ Ѵơ֥
	P6KEYsym K6Table[KVC_LAST];		// ۥ -> P6 Ѵơ֥
	BYTE MatTable[KP6_LAST];		// P6 -> ޥȥꥯ Ѵơ֥
	
	int KbdType;					// ܡɥ
	
	// ü쥭 ե饰
	BOOL ON_SHIFT;	// SHIFT
	BOOL ON_GRAPH;	// GRAPH
	BOOL ON_KANA;	// 
	BOOL ON_KKANA;	// 
	BOOL ON_CTRL;	// CTRL
	BOOL ON_STOP;	// STOP
	BOOL ON_CAPS;	// CAPS
	
	// ưϾ¤
	typedef struct{
		char *Buffer;			// Хåեݥ
		int Num;				// Ĥʸ
		int Wait;				// Ԥ
		BOOL Relay;				// 졼åOFFԤե饰
		int Seek;
	} AKEY;
	AKEY ak;					// ưϾ
	
	char GetAutoKey();			// ư1ʸ
	
	BYTE P6Matrix[NOM*2];		// ޥȥꥯ (Ⱦ: Ⱦ:)
	BYTE P6Mtrx[NOM*2];			// ޥȥꥯ¸
								//  2byteϥ祤ƥåξ¸

public:
	KEY6( VM6 *, const P6ID& );			// 󥹥ȥ饯
	virtual ~KEY6();					// ǥȥ饯
	
	void EventCallback( int, int );		// ٥ȥХåؿ
	
	BOOL Init( int, BOOL );				// 
	
	void UpdateMatrix( SDL_Event * );	// ޥȥꥯ
	BOOL ScanMatrix();					// ޥȥꥯ
	int GetMatrixSize();				// ޥȥꥯ
	BYTE *GetMatrix();					// ޥȥꥯݥ󥿼
	BYTE *GetMatrix2();					// ޥȥꥯݥ(¸)
	
	BYTE GetKeyJoy();					// 륭ּ
	BYTE GetKeyIndicator();				// ܡɥ󥸥ּ
	
	BOOL SetAutoKey( char *, int );		// ưʸ
	BOOL SetAutoKeyFile( char * );		// ưʸ(ե뤫)
	
	void SetVKeySymbols( VKeyConv * );	// ۥ -> P6 
	
	BYTE GetJoy();						// 祤ƥåּ
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class KEY60 : public KEY6 {
public:
	KEY60( VM6 *, const P6ID& );		// 󥹥ȥ饯
	~KEY60();							// ǥȥ饯
};


#endif	// KEYBOARD_H_INCLUDED
