#ifndef OSD_H_INCLUDED
#define OSD_H_INCLUDED

// OS¸ѥ롼(UI)

#include <limits.h>

#include "pc6001v.h"
#include "keydef.h"


// ܡɥ
#define	KB_UNKNOWN	(0)	/* Unknown     */
#define	KB_PS2WD	(1)	/* PS2 windib  */
#define	KB_PS2DX	(2)	/* PS2 directx */
#define	KB_USBWD	(3)	/* USB windib  */
#define	KB_USBDX	(4)	/* USB directx */


#ifdef __cplusplus
extern "C" 
{
#endif

// ե
enum FileMode{ FM_Load, FM_Save };
enum FileDlg{ FD_TapeLoad, FD_TapeSave, FD_Disk, FD_ExtRom, FD_Printer, FD_FontZ, FD_FontH,
			  FD_DokoLoad, FD_DokoSave, FD_RepLoad, FD_RepSave, FD_AVISave, FD_LoadAll, EndofFileDlg };

// --- ʸؿ ---
// ʸˤʸ
//   stricmp ؿ not ANSI,not POSIXǤMSȼĥ?
#ifndef stricmp
int stricmp ( const char *, const char * );
#endif

// --- ѥ̾ؿ ---
// ѥΥǥߥ'/'Ѵ
void Delimiter( char * );
// ѥΥǥߥOSǥեȤѴ(Windowsʤ'\')
void UnDelimiter( char * );
// ѥ˥ǥߥɲ
void AddDelimiter( char * );
// ѥΥǥߥ
void DelDelimiter( char * );

// --- ץؿ ---
// ¿ŵưå
BOOL OSD_IsWorking();
// λ
void OSD_Finish();

// --- եؿ ---
// ⥸塼ѥ
const char *OSD_GetModulePath();
// ե¸ߥå
BOOL OSD_FileExist( const char * );
// եѥե̾
const char *OSD_GetFileNamePart( const char * );
// եλ
const char *OSD_FolderDiaog( void *, char * );
// եλ
const char *OSD_FileDiaog( void *, FileMode, const char *, const char *, char *, char *, const char * );
// Ƽե
const char *OSD_FileSelect( void *, FileDlg, char *, char * );

// --- åɽؿ ---
// åɽ
int OSD_Message( const char *, const char *, int );

// --- Ͻطؿ ---
// ܡɥ׼
int OSD_GetKeyboardType( int );
// 
int OSD_KeyCodeFix( int, BYTE, int );

// --- ¾λؿ ---
// ̾
const char *OSD_ColorName( int );
// ̾
const char *OSD_KeyName( PCKEYsym );
// եȥե
BOOL OSD_CreateFont( char *, char *, int );


// åܥåΥ
#define	OSDM_OK				0x000
#define	OSDM_OKCANCEL		0x001
#define	OSDM_YESNO			0x002
#define	OSDM_YESNOCANCEL	0x003

// åܥåΥ󥿥
#define	OSDM_ICONERROR		0x010
#define	OSDM_ICONQUESTION	0x020
#define	OSDM_ICONWARNING	0x030
#define	OSDM_ICONINFO		0x040

// åܥå
#define	OSDR_OK				0x00
#define	OSDR_CANCEL			0x01
#define	OSDR_YES			0x02
#define	OSDR_NO				0x03


// --- å ---
// ̥å
extern const char *MsgStr[];
#define	MSG_QUIT			MsgStr[0]	// "λƤǤ?"
#define	MSG_QUITC			MsgStr[1]	// "λǧ"
#define	MSG_RESTART0		MsgStr[2]	// "ƵưƤǤ?"
#define	MSG_RESTART			MsgStr[3]	// "ѹϺƵưͭȤʤޤ\nƵưޤ?"
#define	MSG_RESTARTC		MsgStr[4]	// "Ƶưǧ"
#define	MSG_RESETI			MsgStr[5]	// "ĥROMƥꥻåȤޤ"
#define	MSG_RESETE			MsgStr[6]	// "ĥROMӽФƥꥻåȤޤ"
#define	MSG_RESETC			MsgStr[7]	// "ꥻåȳǧ"


// ˥塼ѥå ------
extern const char *MsgMen[];
// [ƥ]
#define	MSMEN_AVI0			MsgMen[0]	// "ӥǥץ..."
#define	MSMEN_AVI1			MsgMen[1]	// "ӥǥץ"
#define	MSMEN_REP0			MsgMen[2]	// "Ͽ..."  (ץ쥤)
#define	MSMEN_REP1			MsgMen[3]	// "Ͽ" (ץ쥤)
#define	MSMEN_REP2			MsgMen[4]	// "..."  (ץ쥤)
#define	MSMEN_REP3			MsgMen[5]	// "" (ץ쥤)


// INIեѥå ------
extern const char *MsgIni[];
// [CONFIG]
#define	MSINI_TITLE			MsgIni[0]	// "; === PC6001V ե ===\n\n"
#define	MSINI_Model			MsgIni[1]	// "  60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR"
#define	MSINI_FDD			MsgIni[2]	// " FDD³ (0-2)"
#define	MSINI_ExtRam		MsgIni[3]	// " ĥRAM"
#define	MSINI_TurboTAPE		MsgIni[4]	// " Turbo TAPE Yes:ͭ No:̵"
#define	MSINI_BoostUp		MsgIni[5]	// " BoostUp Yes:ͭ No:̵"
#define	MSINI_MaxBoost60	MsgIni[6]	// " BoostUp Ψ(N60⡼)
#define	MSINI_MaxBoost62	MsgIni[7]	// " BoostUp Ψ(N60m/N66⡼)
#define	MSINI_OverClock		MsgIni[8]	// " СåΨ (1-1000)%"
#define	MSINI_CheckCRC		MsgIni[9]	// " CRCå TRUE:ͭ FALSE:̵"
// [DISPLAY]
#define	MSINI_ScrBpp		MsgIni[10]	// " 顼⡼ 8:8bit 16:16bit 24:24bit"
#define	MSINI_Mode4Color	MsgIni[11]	// " MODE4顼⡼ 0:Υ 1:/ 2:/ 3:ԥ/ 4:/ԥ"
#define	MSINI_ScanLine		MsgIni[12]	// " 饤 Yes: No:ʤ"
#define	MSINI_ScanLineBr	MsgIni[13]	// " 饤 (0-100)%"
#define	MSINI_DispNTSC		MsgIni[14]	// " 4:3ɽ Yes:ͭ No:̵"
#define	MSINI_FrameSkip		MsgIni[15]	// " ե졼ॹå"
// [SOUND]
#define	MSINI_SampleRate	MsgIni[16]	// " ץ󥰥졼 (44100/22050/11025)Hz"
#define	MSINI_SoundBuffer	MsgIni[17]	// " ɥХåե"
#define	MSINI_MasterVolume	MsgIni[18]	// " ޥ (0-100)"
#define	MSINI_PsgVolume		MsgIni[19]	// " PSG (0-100)"
#define	MSINI_VoiceVolume	MsgIni[20]	// "  (0-100)"
#define	MSINI_TapeVolume	MsgIni[21]	// " TAPE˥ (0-100)"
// [MOVIE]
#define	MSINI_AviRle		MsgIni[22]	// " RLEե饰 TRUE:RLEͭ FALSE:٥"
// [FILES]
#define	MSINI_ExtRom		MsgIni[23]	// " ĥROMե̾"
#define	MSINI_tape			MsgIni[24]	// " TAPE(LODE)ե̾(ư˼ưޥ)"
#define	MSINI_save			MsgIni[25]	// " TAPE(SAVE)ե̾(SAVE˼ưޥ)"
#define	MSINI_disk			MsgIni[26]	// " DISKե̾(ư˼ưޥ)"
#define	MSINI_printer		MsgIni[27]	// " ץ󥿽ϥե̾"
#define	MSINI_fontz			MsgIni[28]	// " ѥեȥե̾"
#define	MSINI_fonth			MsgIni[29]	// " Ⱦѥեȥե̾"
// [PATH]
#define	MSINI_RomPath		MsgIni[30]	// " ROM᡼Ǽѥ"
#define	MSINI_TapePath		MsgIni[31]	// " TAPE᡼Ǽѥ"
#define	MSINI_DiskPath		MsgIni[32]	// " DISK᡼Ǽѥ"
#define	MSINI_ExtRomPath	MsgIni[33]	// " ĥROM᡼Ǽѥ"
#define	MSINI_ImgPath		MsgIni[34]	// " ʥåץåȳǼѥ"
#define	MSINI_WavePath		MsgIni[35]	// " WAVEեǼѥ"
#define	MSINI_FontPath		MsgIni[36]	// " FONTǼѥ"
// [CHECK]
#define	MSINI_CkQuit		MsgIni[37]	// " λǧ TRUE: FALSE:ʤ"
// [KEY]
#define	MSINI_KeyRepeat		MsgIni[38]	// " ԡȤδֳ(ñ:ms 0̵)"
#define	MSINI_UsePS2KBD		MsgIni[39]	// " PS/2ܡɻȤ? Yes:PS/2 No:USB"


// ɤǤSAVEѥå ------
extern const char *MsgDok[];
#define	MSDOKO_TITLE		MsgDok[0]	// "; === PC6001V ɤǤSAVEե ===\n\n"


// Errorѥå ------
extern const char *MsgErr[];
#define	MSERR_ERROR				MsgErr[0]	// "Error"
#define	MSERR_NoError			MsgErr[1]	// "顼Ϥޤ"
#define	MSERR_Unknown			MsgErr[2]	// "Υ顼ȯޤ"
#define	MSERR_MemAllocFailed	MsgErr[3]	// "γݤ˼Ԥޤ"
#define	MSERR_RomChange			MsgErr[4]	// "ꤵ줿ROM᡼Ĥʤᵡѹޤ\nǧƤ"
#define	MSERR_NoRom				MsgErr[5]	// "ROM᡼Ĥޤ\nȥե̾ǧƤ"
#define	MSERR_RomSizeNG			MsgErr[6]	// "ROM᡼ΥǤ"
#define	MSERR_RomCrcNG			MsgErr[7]	// "ROM᡼CRCǤ"
#define	MSERR_SDLInitFailed		MsgErr[8]	// "饤֥(SDL)ν˼Ԥޤ"
#define	MSERR_InitFailed		MsgErr[9]	// "˼Ԥޤ\nǧƤ"
#define	MSERR_FontFailed		MsgErr[10]	// "եȤɹߤ˼Ԥޤ"
#define	MSERR_IniDefault		MsgErr[11]	// "INIեɹߤ˼Ԥޤ\nǥեǵưޤ"
#define	MSERR_IniReadFailed		MsgErr[12]	// "INIեɹߤ˼Ԥޤ"
#define	MSERR_IniWriteFailed	MsgErr[13]	// "INIե¸˼Ԥޤ"
#define	MSERR_TapeMountFailed	MsgErr[14]	// "TAPE᡼ΥޥȤ˼Ԥޤ"
#define	MSERR_DiskMountFailed	MsgErr[15]	// "DISK᡼ΥޥȤ˼Ԥޤ"
#define	MSERR_ExtRomMountFailed	MsgErr[16]	// "ĥROM᡼ΥޥȤ˼Ԥޤ"
#define	MSERR_DokoReadFailed	MsgErr[17]	// "ɤǤLOAD˼Ԥޤ"
#define	MSERR_DokoWriteFailed	MsgErr[18]	// "ɤǤSAVE˼Ԥޤ"
#define	MSERR_DokoDiffModel		MsgErr[19]	// "ɤǤLOAD˼Ԥޤ\n¸ȵ郎ۤʤޤ"
#define	MSERR_DokoDiffVersion	MsgErr[20]	// "ɤǤLOAD˼Ԥޤ\n¸PC6001VΥС󤬰ۤʤޤ"
#define	MSERR_ReplayPlayError	MsgErr[21]	// "ץ쥤˼Ԥޤ"
#define	MSERR_ReplayRecError	MsgErr[22]	// "ץ쥤Ͽ˼Ԥޤ"
#define	MSERR_NoReplayData		MsgErr[23]	// "ץ쥤ǡޤ"



#ifdef __cplusplus
}
#endif


#endif	// OSD_H_INCLUDED
